'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = function (pluginContext) {
  var config = pluginContext.configHelpers.configKey;
  var TermPickerInput = pluginContext.inputComponents.TermPickerInput;


  return {
    dateAssociation: {},
    dateDisplayDate: {},
    dateEarliestScalarValue: {},
    dateEarliestSingleCertainty: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateEarliestSingleCertainty.fullName',
          defaultMessage: 'Earliest/single date certainty'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'datecertainty'
        }
      }
    }),
    dateEarliestSingleDay: {},
    dateEarliestSingleEra: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateEarliestSingleEra.fullName',
          defaultMessage: 'Earliest/single date era'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'dateera'
        }
      }
    }),
    dateEarliestSingleMonth: {},
    dateEarliestSingleQualifier: {},
    dateEarliestSingleQualifierUnit: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateEarliestSingleQualifierUnit.fullName',
          defaultMessage: 'Earliest/single date qualifier unit'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'datequalifier'
        }
      }
    }),
    dateEarliestSingleQualifierValue: {},
    dateEarliestSingleYear: {},
    dateLatestCertainty: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateLatestCertainty.fullName',
          defaultMessage: 'Latest date certainty'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'datecertainty'
        }
      }
    }),
    dateLatestDay: {},
    dateLatestEra: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateLatestEra.fullName',
          defaultMessage: 'Latest date era'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'dateera'
        }
      }
    }),
    dateLatestMonth: {},
    dateLatestQualifier: {},
    dateLatestQualifierUnit: _defineProperty({}, config, {
      messages: {
        fullName: {
          id: 'field.ext.structuredDate.dateLatestQualifierUnit.fullName',
          defaultMessage: 'Latest date qualifier unit'
        }
      },
      view: {
        type: TermPickerInput,
        props: {
          source: 'datequalifier'
        }
      }
    }),
    dateLatestQualifierValue: {},
    dateLatestScalarValue: {},
    dateLatestYear: {},
    dateNote: {},
    datePeriod: {},
    scalarValuesComputed: {}
  };
};